Attribute VB_Name = "modFormular"
' vb@rchiv - Das groe Visual-Basic Archiv
' Tools & Components - Entwicklerkomponenten fr VB-32 Bit
'
' Copyright 2000-2011 Dieter Otter
' Tipp-Autor: Julis Lszl
'
' Der Programmcode darf fr eigene Zwecke verwendet werden.
' Es ist nicht erlaubt Inhalte des Projektes ohne unserer
' Zustimmung zum Download anzubieten.
'
' Die Beispielskripte sind Computerprogramme, die gem
' des 2 Abs. 1 Nr. 69 aff. UrhG den urheberrechtlichen
' Schutz geniessen und drfen nicht fr eigene ausgegeben
' werden.
'
' Dieter Otter
' Software-Entwicklung & Vertrieb
' info@vbarchiv.de
' http://www.vbarchiv.de
' http://www.visualbasic-archiv.de
'
' info@tools4vb.de
' http://www.tools4vb.de
'======================================================


'----------------------------------------------------------------------------------------------------------------------------
'Sie knnen mit diesem Beispielprojekt eine Anwendung wie folgt nachrsten:
'1.) Modul "modFormular" dem Projekt hinzufgen,
'2.) Sub Main im "modFormular" entfernen,
'3.) "FormularTimerSet" im Programstart aufrufen,
'4.) "FormularTimerKill" aufrufen, wenn die Anwendung beendet wird.
'Wenn die Anwendung in der IDE luft, nicht mit der End Ikon oder Run->End Men der Entwicklungsumgebung beenden,
'weil die Tastatur-berwachung (FormularTimerSet) in diesem Fall nicht zerstrt wird.
'Wenn Sie "systemUbergreifend" auf True setzen, funktioniert die Tastatur-berwachung fr smtliche laufende VB6 Anwendungen.
'----------------------------------------------------------------------------------------------------------------------------

'Aufruf des aktuellen CommonControls (fr XP-Theme):
Private Declare Function InitCommonControls Lib "comctl32.dll" () As Long

'---------------------------------------------------------

'Ermitteln des Eingabefeldes, welches den Focus besitzt:
Private Declare Function GetActiveWindow Lib "user32" () As Long
Private Declare Function GetCurrentProcessId Lib "kernel32" () As Long
Private Declare Function GetForegroundWindow Lib "user32" () As Long
Private Declare Function GetWindowThreadProcessId Lib "user32" ( _
  ByVal hWnd As Long, _
  lpdwProcessId As Long) As Long

Private Declare Function GetFocus Lib "user32" () As Long
Private Declare Function GetClassName Lib "user32" Alias "GetClassNameA" ( _
  ByVal hWnd As Long, _
  ByVal lpClassName As String, _
  ByVal nMaxCount As Long) As Long

Private Declare Function SendMessage Lib "user32" _
  Alias "SendMessageA" ( _
  ByVal hWnd As Long, _
  ByVal wMsg As Long, _
  ByVal wParam As Long, _
  lParam As Any) As Long
'Textbox-Nachricht:
Private Const EM_GETHANDLE = &HBD 'Ermittelt, ob aktuelles Eingabefeld ein multiline-Textbox ist.

Private Declare Function AttachThreadInput Lib "user32" ( _
  ByVal idAttach As Long, _
  ByVal idAttachTo As Long, _
  ByVal fAttach As Long) As Long

Private Type tActiveCtrInfo
  lnghWnd As Long
  strClassName As String
End Type

'---------------------------------------------------------

'Prfen, ob eine bestimmte Taste gedrckt wurde:
Public Declare Function GetAsyncKeyState Lib "user32" ( _
  ByVal vKey As Long) As Integer

'---------------------------------------------------------

'Timer fr Tastatur-berwachung:
Private Declare Function SetTimer Lib "user32" ( _
  ByVal hWnd As Long, _
  ByVal nIDEvent As Long, _
  ByVal uElapse As Long, _
  ByVal lpTimerFunc As Long) As Long

Private Declare Function KillTimer Lib "user32" ( _
  ByVal hWnd As Long, _
  ByVal nIDEvent As Long) As Long

Private lngFormularTimerID As Long

'---------------------------------------------------------

'Tastendruck simulieren:
Private Declare Sub keybd_event Lib "user32" ( _
  ByVal bVk As Byte, _
  ByVal bScan As Byte, _
  ByVal dwFlags As Long, _
  ByVal dwExtraInfo As Long)

Private Const VK_TAB = &H9
Private Const VK_RETURN = &HD
Private Const VK_ESCAPE = &H1B
Private Const VK_UP = &H26
Private Const VK_DOWN = &H28
'Siehe frmMain.Text6_KeyPress:
Public Const VK_SHIFT = &H10

Private Const VK_LBUTTON = &H1
Private Const VK_RBUTTON = &H2
Private Const VK_MBUTTON = &H4

Private Const KEYEVENTF_EXTENDEDKEY = &H1
Private Const KEYEVENTF_KEYUP = &H2

'---------------------------------------------------------

'Fenster sichtbar im Taskbar:
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" ( _
  ByVal hWnd As Long, _
  ByVal nIndex As Long) As Long
 
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" ( _
  ByVal hWnd As Long, _
  ByVal nIndex As Long, _
  ByVal dwNewLong As Long) As Long
 
Private Declare Function ShowWindow Lib "user32" ( _
  ByVal hWnd As Long, _
  ByVal nCmdShow As Long) As Long
 
Private Declare Function GetDesktopWindow Lib "user32" () As Long
 
Private Declare Function LockWindowUpdate Lib "user32" ( _
  ByVal hwndLock As Long) As Long
 
Private Const SW_HIDE = 0
Private Const SW_SHOW = 5
Private Const GWL_EXSTYLE = (-20)
Private Const WS_EX_APPWINDOW = &H40000

'---------------------------------------------------------

'hWnd des jeweils letztlich aktivierten Feldes:
Private ReferenzHandle As Long

'Die Tastatur-berwachung funktioniert fr smtliche laufende VB6 Anwendungen, wenn systemUbergreifend = True:
Private systemUbergreifend As Boolean

Private Function Get_Class(ByVal hWnd As Long) As String
    
 'Windows Class des aktiven Feldes:

 Dim Buffer As String
 Dim GetClas As Long
    
 Buffer = Space(250)
 GetClas = GetClassName(hWnd, Buffer, 250)
 Get_Class = Left$(Buffer, GetClas)
    
End Function
Public Sub Main()

 'Die Tastatur-berwachung funktioniert fr smtliche laufende VB6 Anwendungen, wenn systemUbergreifend = True:
 systemUbergreifend = True
 
 'XP-Theme (immer aus Sub Main aufrufen):
 InitCommonControls
 
 'Timer Prozedur zur Tastatur-berwachung aufrufen:
 FormularTimerSet
 
 frmMain.Show 1

End Sub

Private Sub Set_Focus(ByVal hWnd As Long, _
                      ByVal uMsg As Long, _
                      ByVal idEvent As Long, _
                      ByVal dwTime As Long)
 
 'Tastatur-berwachung (http://msdn.microsoft.com/en-us/library/ms644907(v=VS.85).aspx)
 
 'Die Funktion bearbeitet folgende Felder (Class ist unterschiedlich in der IDE bzw. EXE):
 ' _________________________________________________________________________________
 '|                       |                           |                             |
 '| FELD                  | IDE CLASS                 | EXE CLASS                   |
 '|_______________________|___________________________|_____________________________|
 '|                       |                           |                             |
 '| TextBox               | ThunderTextBox            | ThunderRT6TextBox           |
 '|_______________________|___________________________|_____________________________|
 '|                       |                           |                             |
 '| ComboBox              | ThunderComboBox           | ThunderRT6ComboBox          |
 '|_______________________|___________________________|_____________________________|
 '|                       |                           |                             |
 '| DTPicker              | DTPicker20WndClass        | DTPicker20WndClass          |
 '|_______________________|___________________________|_____________________________|
 '|                       |                           |                             |
 '| OptionButton          | ThunderOptionButton       | ThunderRT6OptionButton      |
 '|_______________________|___________________________|_____________________________|
 
 
 On Error GoTo Set_FocusFehler
 
 If systemUbergreifend = True Then
  If Get_ButtonStatus <> 0 Then
   'Die evtl. Doppelklick-Ereignissprozedur einer Fremdanwendung funktioniert nicht, wenn irgendeine Maustaste bettigt wurde und Set_Focus weiterluft.
   'Grundlage ist mir unbekannt.
   'Also raus hier:
   Exit Sub
  End If
 End If
  
 Dim KeyCode As Integer
 Dim TypeOfControl As String
 Dim FensterHandle As Long
 Dim FeldHandle As Long
 Dim hText As Long
 
 'hWnd Eigenschaft des aktiven Feldes:
 FeldHandle = GetFocus()
 
 If FeldHandle = 0 And systemUbergreifend = True Then
  'Wenn das aktive Feld einer Fremdanwendung gehrt:
  FeldHandle = GetActiveControl.lnghWnd
 End If
 
 If FeldHandle = 0 Then
  Exit Sub
 End If

 'Welche Taste gedrckt (systembergreifend):
 If GetAsyncKeyState(VK_RETURN) Then
   KeyCode = 13
  ElseIf GetAsyncKeyState(VK_DOWN) Then
   KeyCode = 40
  ElseIf GetAsyncKeyState(VK_UP) Then
   KeyCode = 38
  ElseIf GetAsyncKeyState(VK_ESCAPE) Then
   KeyCode = 27
 End If
 
 If KeyCode <> 0 Then
  'Windows Class des aktiven Controls (systembergreifend):
  TypeOfControl = Get_Class(FeldHandle)
 End If

 Select Case KeyCode
  Case 40: 'Pfeiltaste unten
   'If ... _ = IDE Class
   'Or ... Then  = EXE Class:
   If TypeOfControl = "ThunderTextBox" _
   Or TypeOfControl = "ThunderRT6TextBox" Then
    'TextBox.Multiline Eigenschaft ermitteln:
    hText = SendMessage(FeldHandle, EM_GETHANDLE, 0&, ByVal 0&)
    If hText = 0 Then
     'Wenn TextBox.Multiline = False, TAB drcken um Fokus auf das nchstfolgende Eingabefeld zu setzen:
     TAB_Druecken
    End If
   End If
  Case 13: 'Enter
   If TypeOfControl = "ThunderTextBox" Or TypeOfControl = "ThunderComboBox" Or TypeOfControl = "DTPicker20WndClass" Or TypeOfControl = "ThunderOptionButton" _
   Or TypeOfControl = "ThunderRT6TextBox" Or TypeOfControl = "ThunderRT6ComboBox" Or TypeOfControl = "DTPicker20WndClass" Or TypeOfControl = "ThunderRT6OptionButton" Then
    '.Multiline Eigenschaft ermitteln:
    hText = SendMessage(FeldHandle, EM_GETHANDLE, 0&, ByVal 0&)
    If hText = 0 Then
     'Wenn .Multiline = False, TAB drcken um Fokus auf das nchstfolgende Eingabefeld zu setzen:
     TAB_Druecken
    Else
     If GetAsyncKeyState(VK_SHIFT) Then
      'Wenn .Multiline = True und Shift + Enter gedrckt, TAB drcken um Fokus auf das vorherige Eingabefeld zu setzen:
      TAB_Druecken
     End If
    End If
   End If
  Case 27: 'Escape
   'Sollte Escape eine gesonderte Funktion haben, sind nachfolgende Kommandozeilen auszukommentieren:
   If TypeOfControl = "ThunderTextBox" Or TypeOfControl = "ThunderComboBox" Or TypeOfControl = "DTPicker20WndClass" Or TypeOfControl = "ThunderOptionButton" _
   Or TypeOfControl = "ThunderRT6TextBox" Or TypeOfControl = "ThunderRT6ComboBox" Or TypeOfControl = "DTPicker20WndClass" Or TypeOfControl = "ThunderRT6OptionButton" Then
    'SHIFT + TAB drcken um Fokus auf das vorherige Eingabefeld zu setzen:
    TAB_Druecken True
   End If
  Case 38: 'Pfeiltaste oben
   If TypeOfControl = "ThunderTextBox" _
   Or TypeOfControl = "ThunderRT6TextBox" Then
    'TextBox.Multiline Eigenschaft ermitteln:
    hText = SendMessage(FeldHandle, EM_GETHANDLE, 0&, ByVal 0&)
    If hText = 0 Then
     'Wenn TextBox.Multiline = False, SHIFT + TAB drcken um Fokus auf das vorherige Eingabefeld zu setzen:
     TAB_Druecken True
    End If
   End If
 End Select
  
 'Wenn Focus auf ein neues Feld gesetzt wurde:
 If FeldHandle <> ReferenzHandle Then
  Hintergrundfarbe
 End If

 ReferenzHandle = FeldHandle
 Exit Sub
 
Set_FocusFehler:

End Sub

Private Function GetActiveControl() As tActiveCtrInfo
  
 'Welches Control hat den Fokus - systembergreifend
 'Source: http://www.vbarchiv.net/tipps/details.php?id=401 (Ronny Hasse):

 Dim strBuffer As String
 Dim lngOtherThreadID As Long
 Dim lngThread1 As Long
 Dim lngThread2 As Long
 Dim lngGetCurrentThreadID As Long
 Dim blnReminder As Boolean
 Dim lnghWndControl As Long
 
 'Prozess-ID der eigenen Anwendung:
 lngThread1 = GetWindowThreadProcessId(frmMain.hWnd, lngGetCurrentThreadID)
 
 'Prozess-ID der aktiven Anwendung:
 lngThread2 = GetWindowThreadProcessId(GetForegroundWindow(), lngOtherThreadID)
 
 'Falls eigene Anwendung nicht die aktive Anwendung:
 If lngThread1 <> lngThread2 Then
  blnReminder = AttachThreadInput(lngThread2, lngThread1, True)
 End If
 
 'Handle des aktuellen Controls:
 lnghWndControl = GetFocus()
 GetActiveControl.lnghWnd = lnghWndControl
 
 If blnReminder Then
  blnReminder = AttachThreadInput(lngThread2, lngThread1, False)
 End If
 
 'Jetzt Klassennamen ermitteln:
 strBuffer = Space(255)
 GetClassName lnghWndControl, strBuffer, Len(strBuffer)
 If InStr(strBuffer, Chr$(0)) > 0 Then
  strBuffer = Left$(strBuffer, InStr(strBuffer, Chr$(0)) - 1)
 End If
 
 If strBuffer = "ThunderRT6TextBox" Or strBuffer = "ThunderRT6ComboBox" Or strBuffer = "DTPicker20WndClass" Or strBuffer = "ThunderRT6OptionButton" Then
  'Wenn VB6 Class:
  GetActiveControl.strClassName = strBuffer
 Else
  'Sonst:
  GetActiveControl.strClassName = ""
  GetActiveControl.lnghWnd = 0
 End If
  
End Function
Private Sub TAB_Druecken(Optional ByVal Shift As Boolean = False)

 'Die VB-interne Funktion "SendKeys" funktioniert unter Vista in der IDE nicht mehr.
 'Wir greifen deshalb auf die Windows Funktion "keybd_event" zurck ("SendKeys" macht vermutlich das gleiche).
 
 If Shift = True Then
  'Shift Taste drcken:
  keybd_event VK_SHIFT, 0, KEYEVENTF_EXTENDEDKEY Or 0, 0
 End If
 
 'TAB Taste drcken:
 keybd_event VK_TAB, 0, 0, 0
 'TAB Taste loslassen:
 keybd_event VK_TAB, 0, KEYEVENTF_KEYUP, 0

 If Shift = True Then
  'Shift Taste loslassen:
  keybd_event VK_SHIFT, 0, KEYEVENTF_EXTENDEDKEY Or KEYEVENTF_KEYUP, 0
 End If
 
End Sub

Private Sub Hintergrundfarbe()

 'Hintergrundfarbe der Eingabefelder:
 
 On Error GoTo HintergrundfarbeFehler
 Dim Eingabefeld As Control
 
 If Not Screen.ActiveForm Is Nothing Then
  For Each Eingabefeld In Screen.ActiveForm.Controls
   If TypeOf Eingabefeld Is TextBox Then
    If Screen.ActiveControl.hWnd = Eingabefeld.hWnd Then
     'Wenn Eingabefeld den Fokus hat:
     Eingabefeld.BackColor = &HC0FFFF
    Else
     'Sonst:
     Eingabefeld.BackColor = &H80000005
    End If
   End If
  Next
 End If
 Exit Sub

HintergrundfarbeFehler:

End Sub
Public Sub FormInTaskbar(lhwnd As Long, ByVal ShowInTaskBar As Boolean)
 
 'Nur aus Main Form aufrufen:
 
 Dim lStyle As Long
 Dim lResult As Long
 
 'Flackern verhindern:
 LockWindowUpdate GetDesktopWindow
 
 'Form ausblenden:
 lResult = ShowWindow(lhwnd, SW_HIDE)
 
 'Window Style festlegen:
 lStyle = GetWindowLong(lhwnd, GWL_EXSTYLE)
 If ShowInTaskBar = True Then
  lStyle = lStyle Or WS_EX_APPWINDOW
 Else
  lStyle = lStyle And Not WS_EX_APPWINDOW
 End If
 
 'Neues Window Style setzen:
 SetWindowLong lhwnd, GWL_EXSTYLE, lStyle
 
 'Form einblenden:
 lResult = ShowWindow(lhwnd, SW_SHOW)
 
 LockWindowUpdate 0&
  
End Sub


Public Sub FormularTimerSet()

 'Nur beim Programstart aufrufen.
 
 'SetTimer Windows API:
 'http://msdn.microsoft.com/en-us/library/ms644906(VS.85).aspx
 'http://support.microsoft.com/kb/180736
 'http://msdn.microsoft.com/en-us/library/ms644907(v=VS.85).aspx
 
 lngFormularTimerID = SetTimer(0, 0, 150, AddressOf Set_Focus)
 
End Sub

Public Sub FormularTimerKill()

 'Nur beim Beenden der Anwendung aufrufen.

 lngFormularTimerID = KillTimer(0, lngFormularTimerID)
 
End Sub

Private Function Get_ButtonStatus() As MouseButtonConstants
    
 'Welche Maustaste gedrckt:
    
 Get_ButtonStatus = 0
 If GetAsyncKeyState(VK_LBUTTON) Then
   Get_ButtonStatus = vbLeftButton
  ElseIf GetAsyncKeyState(VK_RBUTTON) Then
   Get_ButtonStatus = vbRightButton
  ElseIf GetAsyncKeyState(VK_MBUTTON) Then
   Get_ButtonStatus = vbMiddleButton
 End If
    
End Function





